####################################WORK ON nonparametric and semiparametric ways to model dependence#######################################


rm(list=ls())  
getwd()
setwd("C:/Users/PhD Student/OneDrive - King's College London/DATA/CODE ANALYSIS/Model comparison/Bivariate_Models/bivariate_models")
setwd("C:/Users/k1638615/King's College London/OneDrive - King's College London/DATA/CODE ANALYSIS/Model comparison/Bivariate_Models/bivariate_models")

config_file=paste0(getwd(),"/config/config_general.R")
source(config_file)
functions=paste0(getwd(),"/function/Functions_modelComp_AT.R")
source(functions)



dir.study = getwd() 
if (!exists("dir.day"))     dir.day    = paste0(dir.study,"/out/",Sys.Date())
dir.create(dir.day,showWarnings = F,recursive = T)

devplot=F
margins="emp"
mode="AD"
sdl1<-c(0.25,0.5,0.5,0.25,0.5,1.5)
sdl2<-c(0.25,0.25,0.5,1.5,1.5,1.5)
sdl<-c(0.25,0.5,1.5) #shape parameter values
mel<-2 #Location parameter
rcvl<-sqrt(exp(sdl^2)-1) #coefficient of variation computed from the shape parameter
rmean<-exp(mel+0.5*sdl^2) #mean of the distribution
rvar<-exp(sdl^2+2*mel)* (exp(sdl^2)-1) #variance of the distribution
rsd<-sqrt(rvar) #standard deviation of the distribution
rcv<-rsd/rmean #coefficient of variation computed from mean and sd of the distribution




#####Plot the marginal distributions used in the analysis###################

margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl[1])
dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl[1])
colorzz<-c("purple","red","green")
plot(margdist[order(margdist)], dde[order(margdist)] ,type="l", xlim=c(0,30), col="purple",lwd=2,xlab="x", ylab="PDF", main = "three different log-normal distributions")
grid (NULL,NULL, lty = 1, col = "lightgray")
legend(20,0.16,title = "Coefficient of variation",legend=c(paste("A - cv = ",round(rcv[1],2)),paste( "B - cv = ", round(rcv[2],2)),paste( "C - cv = ", round(rcv[3],2))),
       col=c("purple", "red", "green"), lty=c(1,1,1), cex=.9, lwd=2)

for (ssd in 1:length(sdl)){
  margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl[ssd])
  dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl[ssd])
  lines(margdist[order(margdist)], dde[order(margdist)] ,type="l", lwd=2,col=colorzz[ssd])
}

for (ssd in 1:length(sdl)){
  margdist<-rlnorm(10000,meanlog=mel,sdlog = sdl[ssd])
  median(margdist)
  cv=rcv[ssd]
  plot(margdist,main = paste("timeserie of log-normal distributions for cv = ",round(cv,2)),ylab="x",log="y")
  abline(h=median(margdist),lwd=2,col="red")
}


#############BEGINNING OF MAIN LOOP######################


medianECL=c()
q1ECL<-c()
q2ECL<-c()
rmseetaT<-c()
eucldisT<-c()

for(ms in (2:6)){
  sdlog1=sdl1[ms]
  sdlog2<-sdl2[ms]
  margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl1[ms])
  dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl1[ms])
  margdist2<-rlnorm(1000,meanlog=mel,sdlog = sdl2[ms])
  dde2<-dlnorm(margdist2,meanlog=mel,sdlog = sdl2[ms])
  plot(margdist[order(margdist)], dde[order(margdist)] ,type="l", xlim=c(0,30), col="purple",lwd=2)
  lines(margdist2[order(margdist2)], dde2[order(margdist2)] ,type="l", lwd=2,col="blue")



  chiv1<-c(0.05,0.1,0.3,0.5,0.7,0.9)
  thx=1/log2(2-chiv1)
  etali<-c(0.25,0.5,0.75,0.9)
  rhx=2*etali-1
  if (mode=="AD"){
    depx<-thx}
  if (mode=="AI"){
    depx<-rhx}
  library(acopula)
  library(copBasic)
  NORMcop <- function(u,v, para=NULL) {
    if(length(u) == 1) u <- rep(u, length(v)) # see asCOP() for reasoning of
    if(length(v) == 1) v <- rep(v, length(u)) # this "vectorization" hack
    return(copula::pCopula(matrix(c(u,v), ncol=2),normalCopula(para)))
  }
  emLCx<-c()
  emLCy<-c()
  for (b in 1:length(depx)){
    nsim=100
    meanlog1=mel
    meanlog2=mel
    if (mode=="AD"){
      chi=chiv1[b]
      dep=chiv1[b]
      theta=thx[b]
      pq=theta
      cop=GHcop
      
      # dir.coef    = paste0(dir.study,"/out/",Sys.Date(),"/chi_",round(chi,2),"_sd_",sdlog1,"_",sdlog2)
      # dir.create(dir.coef,showWarnings = F,recursive = T)
      gc<-gumbelCopula(theta, dim=2)
      vtau=tau(gc)}
    if (mode=="AI"){
      eta=etali[b]
      dep=eta
      rho=rhx[b]
      pq=rho
      cop=NORMcop
      vtau<-2*asin(rho)/pi
      # dir.coef    = paste0(dir.study,"/out/",Sys.Date(),"/eta ",round(eta,2),"_sd_",sdlog1,"_",sdlog2)
      # dir.create(dir.coef,showWarnings = F,recursive = T)
      gc<-normalCopula(rho, dim=2)}
    
    
    nbpt<-c(500,1000,2000,5000,10000)
    nb=4
    num.points=nbpt[nb]
    # 
    # rmseeta<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # rmsechi<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # ksresults<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # cvmresults<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # eucldist<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # eucldistN<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # bias<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # biasN<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # totalchi<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    # totaleta<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    
    
    
    omg<-mvdc(gc, margins = c("lnorm","lnorm"), paramMargins= list(list(meanlog =mel, sdlog = sdlog1), list(meanlog = mel, sdlog = sdlog2)), marginsIdentical = F, check = TRUE, fixupNames = TRUE)
    
    
    ####################Plots and tests######################
    
    u1<-rMvdc(num.points,omg) #synthetic data
    u1<-as.data.frame(u1)
    
    ngrid1=40
    ngrid2=80
    pobj=0.001
    ra1<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="l",pobj = pobj)
    ra2<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="m",pobj = pobj)
    ra3<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="t",pobj = pobj)
    
    plot(u1)
    
    points(ra1,col=2,type="o")
    points(ra2,col=3,type="o")
    points(ra3,col=4,type="o")
    
    ra<-rbind(ra1,ra2,ra3)
    if(length(ra[,1])<102){
      repeat{
        mirror<-ra[c(length(ra[,1]):1),]
        ra<-rbind(ra,mirror)
        if(length(ra[,1])>=102) break
      }
      ra<-round(ra,8)
      ra<-ra[order(ra[,1],-ra[,2]),]
      ra[,1]<-jitter(ra[,1])
    }
    ra<-round(ra,8)
    ra<-ra[order(ra[,1],-ra[,2]),]
    ra<-digit.curves.p(start=c(ra[1,1],ra[1,2]), as.matrix(ra), nPoints=98, closed = FALSE)
    ra<-densicurvcop1(ra,omg)
    plot(ra[,1],ra[,2])
    
    ########LOOP 100 times##########################################################
    empilines<-list()
    Weucldist<-as.data.frame(matrix(0, ncol = 1, nrow = nsim))
    emlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    emliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    library(goftest)
    JointExcureve_file=paste0(getwd(),"/function/Joint_excurves.R")
    source (JointExcureve_file)
    for (jo in 1:nsim){
      
      print(paste0("lap # ", jo," pars " ,ms,b))
      start_time <- Sys.time()
      
      u2<-rMvdc(num.points,omg) #synthetic data
      u2<-as.data.frame(u2)
      id<-seq(1,length(u2[,2]))
      u3<-cbind(u2,id)
      tauemp<-cor(u2$V1,u2$V2,method="kendall")
      print(tauemp)
      denslim<-1e-9
      pobj=0.001
      j1 <- calcJointExceedanceCurve(u2,pobj,n=50) 
 
      j1o<-data.frame(j1[[1]],j1[[2]])
      points(j1o,col=2)
      empilines<-c(empilines,list(j1o))
      Weucldist[jo,]<-Diagnostix(ra,j1o)[3]
      emlinex[,jo]<-j1[[1]]
      emliney[,jo]<-j1[[2]]
    } 
    plot(Weucldist)
    round(median(as.numeric(Weucldist$V1)),3)
      # if(mode=="AI"){
      #   rmseEtaM[,1]<-median(as.numeric(rmseeta[,los]))
      #   rmseEtaM[,2]<-quantile(as.numeric(rmseeta[,los]),.025,na.rm=T)
      #   rmseEtaM[,3]<-quantile(as.numeric(rmseeta[,los]),.975,na.rm=T)
      #   
      #   EtaM[los,1]<-median(as.numeric(totaleta[,los]))
      #   EtaM[los,2]<-quantile(as.numeric(totaleta[,los]),.025,na.rm=T)
      #   EtaM[los,3]<-quantile(as.numeric(totaleta[,los]),.975,na.rm=T)
      # }
      # if(mode=="AD"){
      #   rmseChiM[los,1]<-median(as.numeric(rmsechi[,los]))
      #   rmseChiM[los,2]<-quantile(as.numeric(rmsechi[,los]),.025,na.rm=T)
      #   rmseChiM[los,3]<-quantile(as.numeric(rmsechi[,los]),.975,na.rm=T)
      #   
      #   ChiM[los,1]<-median(as.numeric(totalchi[,los]))
      #   ChiM[los,2]<-quantile(as.numeric(totalchi[,los]),.025,na.rm=T)
      #   ChiM[los,3]<-quantile(as.numeric(totalchi[,los]),.975,na.rm=T)
      # }
      # ksresultM[los,1]<-median(as.numeric(ksresults[,los]))
      # ksresultM[los,2]<-quantile(as.numeric(ksresults[,los]),.025,na.rm=T)
      # ksresultM[los,3]<-quantile(as.numeric(ksresults[,los]),.975,na.rm=T)
      # 
      # cvmresM[los,1]<-median(as.numeric(cvmresults[,los]))
      # cvmresM[los,2]<-quantile(as.numeric(cvmresults[,los]),.025,na.rm=T)
      # cvmresM[los,3]<-quantile(as.numeric(cvmresults[,los]),.975,na.rm=T)
      eucldisLM<-matrix(ncol=3,nrow=1)
      eucldisLM[,1]<-median(as.numeric(Weucldist[,1]),na.rm=T)
      eucldisLM[,2]<-quantile(as.numeric(Weucldist[,1]),.025, na.rm=T)
      eucldisLM[,3]<-quantile(as.numeric(Weucldist[,1]),.975,na.rm=T)
      
      formL<-matrix(ncol=3,nrow=100)
      emlinesICx<-formL
      emlinesICy<-formL
      
      
      x1<-c()
      x2<-c()
      x3<-c()
      for (ios in 1:nsim)
      {
        x1<-c(x1,as.numeric(emlinex[,ios]))
        x2<-c(x2,as.numeric(emliney[,ios]))
        # x3<-c(x3,as.numeric(linesfinald[[los]][,ios]))
        # 
      }
      scs1<-scale(as.numeric(x1),center=F)
      ss1<-attr(scs1,'scaled:scale')
      scs2<-scale(as.numeric(x2),center=F)
      ss2<-attr(scs2,'scaled:scale')
      x1p<-as.vector(scale(as.numeric(x1),center=F))
      x2p<-as.vector(scale(as.numeric(x2),center=F))
      poco<-as.data.frame(cbind(x1p,x2p))
      polco<-cart2pol(x1p, x2p)
      lala<-seq(min(polco[,2]),max(polco[,2]),length.out = 100)
      quantile(polco[,2],0.95)
      for(al in 1:100)
      {
        alo<-lala[al]
        
        pre<-matrix(ncol=2,nrow=100)
        for (ibs in 1:nsim){
          
          y1<-as.numeric(emlinex[,ibs])/ss1
          y2<-as.numeric(emliney[,ibs])/ss2
          # y3<-as.numeric(linesfinald[[los]][,ibs])
          fshit<-cbind(y1,y2)
          polco<-cart2pol(y1, y2)
          lapol<-polco[,2]
          sel<-abs(lapol-alo)
          if(length(which(sel==min(sel,na.rm = T)))>1){
            pre[ibs,]<-c(pol2cart(polco[which(sel==min(sel))[1],1],alo))
          }else{pre[ibs,]<-c(pol2cart(polco[which(sel==min(sel)),1],alo))}
          pre[ibs,1]<-pre[ibs,1]*ss1
          pre[ibs,2]<-pre[ibs,2]*ss2
        }
        alex<-as.data.frame(pre)
        emlinesICx[al,1]<-median(alex[,1])
        emlinesICy[al,1]<-median(alex[,2])
        emlinesICx[al,2]<-quantile(alex[,1],0.025)
        emlinesICx[al,3]<-quantile(alex[,1],0.975)
        emlinesICy[al,2]<-quantile(alex[,2],0.025)
        emlinesICy[al,3]<-quantile(alex[,2],0.975)
      }
      plot(emlinesICx[,1],emlinesICy[,1],xlim=c(0,50),ylim=c(0,30))
      points(emlinesICx[,2],emlinesICy[,2],col=2)
      points(emlinesICx[,3],emlinesICy[,3],col=3)
      lines(ra[,c(1,2)])
      eucldisT<-rbind(eucldisT,eucldisLM)
      emLCx<-c(emLCx,list(emlinesICx))
      emLCy<-c(emLCy,list(emlinesICy))
  }
  # medianECL<-c()
  # for (ix in 1:6){
  #   medianECL<-cbind(medianECL,eucldisT[c(1:4)+4*(ix-1),1])
  # }
  # medianECL<-cbind(medianECL,eucldisT[,1])
  plot(eucldisT[,1])
  q1ECL<-cbind(q1ECL,eucldisT[,2])
  q2ECL<-cbind(q2ECL,eucldisT[,3])
  
  
}
  
write.csv(eucldisT,file="out/empirix/weucli_AD.csv")    
