####################################WORK ON nonparametric and semiparametric ways to model dependence#######################################


rm(list=ls())  
getwd()
setwd("C:/Users/PhD Student/OneDrive - King's College London/DATA/CODE ANALYSIS/Model comparison")
setwd("C:/Users/k1638615/King's College London/OneDrive - King's College London/DATA/CODE ANALYSIS/Model comparison")

config_file=paste0(getwd(),"/config/config_general.R")
source(config_file)
functions=paste0(getwd(),"/Multimodel_Sim/Functions_modelComp_AT.R")
source(functions)



dir.study = getwd() 
if (!exists("dir.day"))     dir.day    = paste0(dir.study,"/out/",Sys.Date())
dir.create(dir.day,showWarnings = F,recursive = T)

devplot=F
margins="emp"
mode="AI"
sdl1<-c(0.25,0.5,0.5,0.25,0.5,1.5)
sdl2<-c(0.25,0.25,0.5,1.5,1.5,1.5)
sdl<-c(0.25,0.5,1.5) #shape parameter values
mel<-2 #Location parameter
rcvl<-sqrt(exp(sdl^2)-1) #coefficient of variation computed from the shape parameter
rmean<-exp(mel+0.5*sdl^2) #mean of the distribution
rvar<-exp(sdl^2+2*mel)* (exp(sdl^2)-1) #variance of the distribution
rsd<-sqrt(rvar) #standard deviation of the distribution
rcv<-rsd/rmean #coefficient of variation computed from mean and sd of the distribution




#####Plot the marginal distributions used in the analysis###################

margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl[1])
dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl[1])
colorzz<-c("purple","red","green")
plot(margdist[order(margdist)], dde[order(margdist)] ,type="l", xlim=c(0,30), col="purple",lwd=2,xlab="x", ylab="PDF", main = "three different log-normal distributions")
grid (NULL,NULL, lty = 1, col = "lightgray")
legend(20,0.16,title = "Coefficient of variation",legend=c(paste("A - cv = ",round(rcv[1],2)),paste( "B - cv = ", round(rcv[2],2)),paste( "C - cv = ", round(rcv[3],2))),
       col=c("purple", "red", "green"), lty=c(1,1,1), cex=.9, lwd=2)

for (ssd in 1:length(sdl)){
margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl[ssd])
dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl[ssd])
lines(margdist[order(margdist)], dde[order(margdist)] ,type="l", lwd=2,col=colorzz[ssd])
}

for (ssd in 1:length(sdl)){
  margdist<-rlnorm(10000,meanlog=mel,sdlog = sdl[ssd])
  median(margdist)
  cv=rcv[ssd]
  plot(margdist,main = paste("timeserie of log-normal distributions for cv = ",round(cv,2)),ylab="x",log="y")
  abline(h=median(margdist),lwd=2,col="red")
}


#############BEGINNING OF MAIN LOOP######################

  

for(ms in (1:6)){
  sdlog1=sdl1[ms]
  sdlog2<-sdl2[ms]
  margdist<-rlnorm(1000,meanlog=mel,sdlog = sdl1[ms])
  dde<-dlnorm(margdist,meanlog=mel,sdlog = sdl1[ms])
  margdist2<-rlnorm(1000,meanlog=mel,sdlog = sdl2[ms])
  dde2<-dlnorm(margdist2,meanlog=mel,sdlog = sdl2[ms])
  plot(margdist[order(margdist)], dde[order(margdist)] ,type="l", xlim=c(0,30), col="purple",lwd=2)
  lines(margdist2[order(margdist2)], dde2[order(margdist2)] ,type="l", lwd=2,col="blue")
  Anaout<-list()
  rmsechiT<-c()
  rmseetaT<-c()
  eucldisT<-c()
  eucldisTNorm<-c()
  biasT<-c()
  biasTNorm<-c()
  cvmresT<-c()
  ksresulT<-c()
  totalchiT<-c()
  totaletaT<-c()
  totaltauT<-c()
  paramT<-c()
  chiv1<-c(0.05,0.1,0.3,0.5,0.7,0.9)
  thx=1/log2(2-chiv1)
  etali<-c(0.25,0.5,0.75,0.9)
  rhx=2*etali-1
  if (mode=="AD"){
    depx<-thx}
  if (mode=="AI"){
    depx<-rhx}
  library(acopula)
  library(copBasic)
  NORMcop <- function(u,v, para=NULL) {
    if(length(u) == 1) u <- rep(u, length(v)) # see asCOP() for reasoning of
    if(length(v) == 1) v <- rep(v, length(u)) # this "vectorization" hack
    return(copula::pCopula(matrix(c(u,v), ncol=2),normalCopula(para)))
  }
  
  for (b in 1:length(depx)){
    nsim=100
    meanlog1=mel
    meanlog2=mel
    if (mode=="AD"){
    chi=chiv1[b]
    dep=chiv1[b]
    theta=thx[b]
    pq=theta
    cop=GHcop

    dir.coef    = paste0(dir.study,"/out/",Sys.Date(),"/chi_",round(chi,2),"_sd_",sdlog1,"_",sdlog2)
    dir.create(dir.coef,showWarnings = F,recursive = T)
    gc<-gumbelCopula(theta, dim=2)
    vtau=tau(gc)}
    if (mode=="AI"){
    eta=etali[b]
    dep=eta
    rho=rhx[b]
    pq=rho
    cop=NORMcop
    vtau<-2*asin(rho)/pi
    dir.coef    = paste0(dir.study,"/out/",Sys.Date(),"/eta ",round(eta,2),"_sd_",sdlog1,"_",sdlog2)
    dir.create(dir.coef,showWarnings = F,recursive = T)
    gc<-normalCopula(rho, dim=2)}
    

    nbpt<-c(500,1000,2000,5000,10000)
    nb=4
    num.points=nbpt[nb]
    
    rmseeta<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    rmsechi<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    ksresults<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    cvmresults<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    eucldist<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    eucldistN<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    bias<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    biasN<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    totalchi<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    totaleta<-as.data.frame(matrix(0, ncol = 6, nrow = nsim))
    
     
    HTlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    LTlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Gumlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Normlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    FGMlinex <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Gallinex<- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    
    HTliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    LTliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Gumliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Normliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    FGMliney <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Galliney<- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    
    HTlined <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    LTlined <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Gumlined <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Normlined <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    FGMlined <- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    Gallined<- as.data.frame(matrix(0, ncol = nsim, nrow = 100))
    
 
      omg<-mvdc(gc, margins = c("lnorm","lnorm"), paramMargins= list(list(meanlog =mel, sdlog = sdlog1), list(meanlog = mel, sdlog = sdlog2)), marginsIdentical = F, check = TRUE, fixupNames = TRUE)

    
    ####################Plots and tests######################
   
    u1<-rMvdc(num.points,omg) #synthetic data
    u1<-as.data.frame(u1)

      ngrid1=40
      ngrid2=80

    ra1<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="l")
    ra2<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="m")
    ra3<-xcurvDraw(mvd=omg,u2=u1,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,cop=cop,par=pq,pos="t")
    
    plot(u1)
    
    points(ra1,col=2,type="o")
    points(ra2,col=3,type="o")
    points(ra3,col=4,type="o")
    
    ra<-rbind(ra1,ra2,ra3)
    if(length(ra[,1])<102){
      repeat{
        mirror<-ra[c(length(ra[,1]):1),]
        ra<-rbind(ra,mirror)
        if(length(ra[,1])>=102) break
      }
      ra<-round(ra,8)
      ra<-ra[order(ra[,1],-ra[,2]),]
      ra[,1]<-jitter(ra[,1])
    }
    ra<-round(ra,8)
    ra<-ra[order(ra[,1],-ra[,2]),]
    ra<-digit.curves.p(start=c(ra[1,1],ra[1,2]), as.matrix(ra), nPoints=98, closed = FALSE)
    ra<-densicurvcop1(ra,omg)
    plot(ra[,1],ra[,2])

    ########LOOP 100 times##########################################################
    for (jo in 1:nsim){

       print(paste0("lap # ", jo," pars " ,ms,b))
      start_time <- Sys.time()
     
    u2<-rMvdc(num.points,omg) #synthetic data
    u2<-as.data.frame(u2)
    id<-seq(1,length(u2[,2]))
    u3<-cbind(u2,id)
    tauemp<-cor(u2$V1,u2$V2,method="kendall")
    
    ####################Marginal distributions GPD###########################
    
    tr1=.9
    tr2=.9
    
    th1<-quantile(u2[,1], tr1)
    th2<-quantile(u2[,2], tr2)
    
    gpdbg1<-fevd(u2[,1],threshold =as.numeric(th1), location.fun = ~1,
         scale.fun = ~1, shape.fun = ~1, use.phi = FALSE,
         type = c("GP"),
         method = c("MLE"), time.units = "years")
    
    gpdbg2<-fevd(u2[,2],threshold =as.numeric(th2), location.fun = ~1,
                  scale.fun = ~1, shape.fun = ~1, use.phi = FALSE,
                  type = c("GP"),
                  method = c("MLE"), time.units = "years")
    
    #Unniform margin lnorm
    if(margins=="lnorm"){
    px<-plnorm(u2[,1],meanlog = meanlog1, sdlog = sdlog1)
    py<-plnorm(u2[,2],meanlog = meanlog2, sdlog = sdlog2)
    tooLow1 <- which(u2[,1] <= min(u2[,1]))
    tooLow2 <- which(u2[,2] <= min(u2[,2]))
    px[tooLow1] <- 0
    py[tooLow2] <- 0
    }
    
    if(margins=="emp"){
      epdata <- apply(u2, 2, rank, na.last = "keep")
      nasm <- apply(u2, 2, function(x) sum(!is.na(x)))
      epdata <-  epdata/rep(nasm + 1, each = nrow(data))
      tooLow1 <- which(u2[,1] <= min(u2[,1]))
      tooLow2 <- which(u2[,2] <= min(u2[,2]))
      epdata[tooLow1,1] <- 0
      epdata[tooLow2,2] <- 0
      px<-epdata[,1]
      py<-epdata[,2]
    }
    

    
    parv1<-gpdbg1$results$par
    parv2<-gpdbg2$results$par
    wwe<-(1+parv1[2]*((u2[which(u2[,1]>th1+1),1]-th1)/parv1[1]))
    px1<-1-(1-tr1)*wwe^(-1/parv1[2])
    py1<-1-(1-tr2)*(1+parv2[2]*((u2[which(u2[,2]>th2+1),2]-th2)/parv2[1]))^(-1/parv2[2])
    
    wwe<-(1+parv1[2]*((u2[which(u2[,1]>th1),1]-th1)/parv1[1]))
    pxt<-1-(1-tr1)*wwe^(-1/parv1[2])
    pyt<-1-(1-tr2)*(1+parv2[2]*((u2[which(u2[,2]>th2),2]-th2)/parv2[1]))^(-1/parv2[2])
    
    interw<-1-(1-tr1)*(1+parv1[2]*((u2[which(u2[,1]>th1 & u2[,1]<=th1+1),1]-th1)/parv1[1]))^(-1/parv1[2])
    interr<-1-(1-tr2)*(1+parv2[2]*((u2[which(u2[,2]>th2 & u2[,2]<=th2+1),2]-th2)/parv2[1]))^(-1/parv2[2])
    ww=seq(0,1,length=length(interw))
    wr=seq(0,1,length=length(interr))
    
    empix<-px[which(u2[,1]>th1 & u2[,1]<=th1+1)]
    empiy<-py[which(u2[,2]>th2 & u2[,2]<=th2+1)]
    
    interdw<-((1-ww)*empix+ww*interw)
    interdr<-((1-wr)*empiy+wr*interr)
    
    pxx<-px[-which(u2[,1]>th1)]
    pyy<-py[-which(u2[,2]>th2)]
    
    pxf<-as.numeric(c(pxx,interdw,px1))
    pyf<-as.numeric(c(pyy,interdr,py1))
    
    
    pxp<-c(seq(0.999,0.999999,by=0.000001))
    u1p<-SpatialExtremes::qgpd(pxp, loc=th1, scale=parv1[1], shape=parv1[2], lower.tail = T,lambda=tr1)
    
    pyp<-c(seq(0.999,0.999999,by=0.000001))
    u2p<-SpatialExtremes::qgpd(pyp, loc=th2, scale=parv2[1], shape=parv2[2], lower.tail = TRUE,lambda=tr2) 
    
    u1b<-c(u2[,1],u1p)
    u2b<-c(u2[,2],u2p)
    
    
    pxo<-c(u3[which(u3[,1]<=th1),3],u3[which(u3[,1]>th1 & u3[,1]<=th1+1),3],u3[which(u3[,1]>th1+1),3]) 
    pxf<-pxf[order(pxo)] 
    px<-px[order(pxo)] 

    
    pyo<-c(u3[which(u3[,2]<=th2),3],u3[which(u3[,2]>th2 & u3[,2]<=th2+1),3],u3[which(u3[,2]>th2+1),3])
    pyf<-pyf[order(pyo)]
    if(devplot==T){
    plot(px[order(px)],pxf[order(pxf)],xlim=c(0.9,1),ylim=c(0.9,1),type="p")
    segments(x0=0,y0=0,x1=1,y1=1,col=2)
    plot(pxf[order(pxf)])}
    
    
    pxfp<-as.numeric(c(pxf,pxp))
    pyfp<-as.numeric(c(pyf,pyp))
    
    if(devplot==T){
    plot(pxf,u2[,1])
    plot(pyf,u2[,2])
    
    plot(pxfp,u1b)
    plot(pyfp,u2b)}
    
    
    kk<-data.frame(pxf,pyf)
    
    
    
    
    #########Joint tail model (Cooley et al. , 2019)####################

    print("Joint tail model fitting...")
    
    
    
    jtres<-JT_KDE(u2,pbas=0.01 ,pobj=0.001,beta=200,margins=margins,vtau=vtau,mar1=u2[,1],mar2=u2[,2],px=kk[,1],py=kk[,2])
    jtres$etaJT
    wqobj<-removeNA(jtres$levelcurve)
    wqobj<-data.frame(wqobj)
    wq0ri<-jtres$wq0ri
    wqobj[,1]=jitter(wqobj[,1])
    plot(wqobj)

    #############################   Conditional model      ###################
    
    
    print("Conditional model fitting")

    if(mode=="AI" & b<3){tsim=.9}else{tsim=0.95}

    condexres<-Cond_mod(u2,tr1,tr2,tsim=tsim,num.sim = 5000,pobj=0.001)
        
    
    if(length(wqobj[,1])<102){
      repeat{
      mirror<-wqobj[c(length(wqobj[,1]):1),]
      wqobj<-rbind(wqobj,mirror)
      if(length(wqobj[,1])>=102) break
      }
      wqobj<-round(wqobj,8)
      wqobj<-wqobj[order(wqobj[,1],-wqobj[,2]),]
      wqobj[,1]<-jitter(wqobj[,1])
      }
   
    if(length(wq0ri[,1])<102){
      repeat{
        mirror<-wq0ri[c(length(wq0ri[,1]):1),]
        wq0ri<-rbind(wq0ri,mirror)
        if(length(wq0ri[,1])>=102) break
      }
      wq0ri<-round(wq0ri,8)
      wq0ri<-wq0ri[order(wq0ri[,1],-wq0ri[,2]),]
      wq0ri[,1]<-jitter(wq0ri[,1])
    }
    
    # xlt=seq(min(wqobj[,1]),max(wqobj[,1])-0.1,length.out = 120)
    # xlto=seq(min(wq0ri[,1]),max(wq0ri[,1])-0.1,length.out = 120)
    ltl<-digit.curves.p(start=wqobj[1,], curve=as.matrix(wqobj), nPoints=98, closed = FALSE)
    ltlo<-digit.curves.p(start=wq0ri[1,], as.matrix(wq0ri), nPoints=98, closed = FALSE)
    htl<-digit.curves.p(start=condexres$jline[1,], as.matrix(condexres$jline), nPoints=98, closed = FALSE)

    cem.dens<-kde(condexres$onlysim,gridsize = 100)
    jt.dens<-kde(u2,gridsize = 100)
    
    htl<-densicurvem(cem.dens,htl, tl="h")
    ltl<-densicurvem(jt.dens,ltlo, tl="l", ltl)
    denslim<-1e-9

    
    ##################Copula models#################
    

   
    print("Copula fitting")

    library(VineCopula)
    library(Metrics)

    ##Copula fitting for 4 different copulas
    copulas<-list()
    copulas[[1]]<-fitCopula(gumbelCopula(),data=kk,method="itau")

    copulas[[2]]<-fitCopula(normalCopula(),data=kk,method="itau")

    copulas[[3]]<-fitCopula(fgmCopula(),data=kk, method="itau")

    if (vtau>0)copulas[[4]]<-fitCopula(galambosCopula(),data=kk,method="itau")
    if (vtau<=0)copulas[[4]]<-indepCopula()

    
    library(acopula)
    library(copBasic)
    NORMcop <- function(u,v, para=NULL) {
      if(length(u) == 1) u <- rep(u, length(v)) # see asCOP() for reasoning of
      if(length(v) == 1) v <- rep(v, length(u)) # this "vectorization" hack
      return(copula::pCopula(matrix(c(u,v), ncol=2),normalCopula(para)))
    }
    copbask<-c(GHcop,NORMcop,FGMcop,GLcop,P)


    clines<-list()

    
    for (v in 1:4){
    
      if( v!=4 | vtau>0){
        copulas[[v]]@copula
        c1<-copulas[[v]]@estimate
        }
    if( v==1){o<-gumbelCopula(c1,dim=2)}
    if( v==2)o<-normalCopula(c1,dim=2)
    if( v==3)o<-fgmCopula(c1,dim=2)
    if( v==4 & vtau>0)o<-galambosCopula(c1)
    if( v==4 & vtau<=0)o<-indepCopula(dim=2)
    
    
    if(margins=="lnorm"){
      omf<-mvdc(o, margins = c("lnorm","lnorm"), paramMargins= list(list(meanlog = meanlog1, sdlog = sdlog1), list(meanlog = meanlog2, sdlog = sdlog2)), marginsIdentical = F, check = TRUE, fixupNames = TRUE)
      cli<-xcurvDraw(mvd=omf,u2=u2,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,margins="lnorm",mar1=u1b,mar2=u2b,px=pxfp,py=pyfp)
      clines<-c(clines,list(cli))
    }
    
    if(margins=="emp"){
      # omf<-mvdc(o, margins = c("lnorm","lnorm"), paramMargins= list(list(meanlog = meanlog1, sdlog = sdlog1), list(meanlog = meanlog2, sdlog = sdlog2)), marginsIdentical = F, check = TRUE, fixupNames = TRUE)
      # cli<-xcurvDraw(mvd=omf,u2=u2,meanlog1,meanlog2,sdlog1,sdlog2,n.grid1=ngrid1,n.grid2=ngrid2,ms=ms,margins="emp",mar1=u1b,mar2=u2b,px=pxfp,py=pyfp)
      # clines<-c(clines,list(cli))

    
      coco<-copbask[[v]]
      logm=F
      if(ms>3)logm=T
      if( v==4 & vtau<=0)coco<-copbask[[5]]
      upobj=0.001
      ng=100
      if(v==3)ng=150
      # cl1<-curve.funct.a(px=pxfp,py=pyfp,mar1=u1b,mar2=u2b,u2,pos="l",pobje=upobj,ng=100,inter="comb")
      # cl2<-curve.funct.a(px=pxfp,py=pyfp,mar1=u1b,mar2=u2b,u2,pos="m",pobje=upobj,ng=100,inter="comb")
      cl3<-curve.funct.a(px=pxfp,py=pyfp,mar1=u1b,mar2=u2b,u2,pos="t",pobje=upobj,ng=ng,inter="comb",logm=logm)
# 
#       plot(u2)
# 
#       # points(cl1,col=2,type="o")
#       # points(cl2,col=3,type="o")
#       points(cl3,col=4,type="o")

      cl<-cl3
      cl<-round(cl,8)
      cl<-cl[order(cl[,1],-cl[,2]),]
      cl[,1]<-jitter(cl[,1])
      if(length(cl[,1])<102){
        repeat{
          mirror<-cl[c(length(cl[,1]):1),]
          cl<-rbind(cl,mirror)
          if(length(cl[,1])>=102) break
        }
        cl<-round(cl,8)
        cl<-cl[order(cl[,1],-cl[,2]),]
        cl[,1]<-jitter(cl[,1])
      }
 
      cli<-digit.curves.p(start=c(cl[1,1],cl[1,2]), as.matrix(cl), nPoints=98, closed = FALSE)
      cli<-densicurvcop2(cli,o)
      clines<-c(clines,list(cli))
      
    }

   
    }

    names(clines)=c("gumbel","normal","fgm","galambos")

    #Final plot
    if(devplot==T){
      cols <- c("Cond-Ex" = "purple", "JT-KDE" = "green", "Gumcop" = "red", "Normalcop" = "orange", "FGMcop" = "darkorange", "GalambosCop" = "darkred") 
      adpd<-ra[,c(1,2)]
      plot(u2, col="grey",xlim=c(0,1.15*max(adpd$x)),ylim=c(0,1.15*max(adpd$y)),
           xlab="X1", ylab="X2", cex.lab=1.4,cex.axis=1.4)
      legend(1.5*mean(ra$x),3*mean(ra$y),legend=c("Cond_Ex", "JT-KDE","GumbelCop","NormalCop","FGMCop","GalambosCop"), bg=NULL,
             col=cols, lty=c(1,1,1,3,4,5,6), cex=.9, lwd=2)
      lines(ra[,1],ra[,2],col="blue", lwd=3)
      # contour(lox,loy,az,levels = c(0.1,0.05), add=T, col="darkgreen",delta=0,xlim=c(0,100),ylim=c(0,100),box=F, lwd=4)
      lines(wqobj,col=cols[2], lwd=3)
      lines(htl[,1],htl[,2],col=cols[1], lwd=3,type="l")
      lines(clines[[1]],col=cols[3],lty=3, lwd=3,type="l")
      lines(clines[[2]],col=cols[4],lty=4, lwd=3,type="l")
      lines(clines[[3]],col=cols[5],lty=5, lwd=3,type="l")
      lines(clines[[4]],col=cols[6],lty=6, lwd=3,type="l")
    }
    
    
    
    
    #######################Statistics & Diagnostic tools########################
    
      eucldist[jo,]<-c(Diagnostix(ra,htl)[3],
      Diagnostix(ra,ltl)[3],Diagnostix(ra,clines$gumbel)[3],Diagnostix(ra,clines$normal)[3],
      Diagnostix(ra,clines$fgm)[3],
      Diagnostix(ra,clines$galambos)[3]
      )
      
      eucldistN[jo,]<-c(Diagnostix(ra,htl)[2],
                        Diagnostix(ra,ltl)[2],Diagnostix(ra,clines$gumbel)[2],Diagnostix(ra,clines$normal)[2], Diagnostix(ra,clines$fgm)[2], Diagnostix(ra,clines$galambos)[2]
      )
      
      bias[jo,]<-c(Diagnostix(ra,htl)[4],
                   Diagnostix(ra,ltl)[4],Diagnostix(ra,clines$gumbel)[4],Diagnostix(ra,clines$normal)[4],
                   Diagnostix(ra,clines$fgm)[4],
                   Diagnostix(ra,clines$galambos)[4]
      )
      biasN[jo,]<-c(Diagnostix(ra,htl)[1],
                    Diagnostix(ra,ltl)[1],Diagnostix(ra,clines$gumbel)[1],Diagnostix(ra,clines$normal)[1],
                    Diagnostix(ra,clines$fgm)[1],
                    Diagnostix(ra,clines$galambos)[1]
      )
      # 
      # ksresults[jo,]<-c(Diagnostix(ra,htl)[6],
      #                   Diagnostix(ra,ltl)[6],Diagnostix(ra,clines$gumbel)[6],Diagnostix(ra,clines$normal)[6],
      #                   Diagnostix(ra,clines$fgm)[6],
      #                   Diagnostix(ra,clines$galambos)[6]
      # )
      # 
      # cvmresults[jo,]<-c(Diagnostix(ra,htl)[5],
      #                    Diagnostix(ra,ltl)[5],Diagnostix(ra,clines$gumbel)[5],Diagnostix(ra,clines$normal)[5],
      #                    Diagnostix(ra,clines$fgm)[5],
      #                    Diagnostix(ra,clines$galambos)[5]
      # )
      # 

      names(eucldist)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      names(eucldistN)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      names(bias)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      names(biasN)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      # names(ksresults)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      # names(cvmresults)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
  
      
      if (vtau>0)param<-c(copulas[[1]]@copula@parameters,copulas[[2]]@copula@parameters,copulas[[3]]@copula@parameters,copulas[[4]]@copula@parameters)
      if (vtau<=0)param<-c(copulas[[1]]@copula@parameters,copulas[[2]]@copula@parameters,copulas[[3]]@copula@parameters,NA)
      
      names(param)=c("gumbel","normal","fgm","galambos")
      
      
      tauN<-tau(copulas[[2]]@copula)
      tauGu<-tau(copulas[[1]]@copula)
      taufgm<-tau(copulas[[3]]@copula)
      if(vtau>0)tauGal<-tau(copulas[[4]]@copula)
      if(vtau<=0)tauGal=NA
      taureal<-tau(gc)
      
      totaltau<-c(tauGu,tauN,taufgm,tauGal,taureal)
      names(totaltau)=c("gumbel","normal","fgm","galambos","real")
    
      if (mode=="AD"){
      chiht<-condexres$chiHT
      chilt<-jtres$chiJT
      chiGum<-2-2^(1/param[1])
      chifgm=0
      chiNorm<-BiCopPar2TailDep(1, par=param[2])$upper
      if(vtau>0){
      An<-abvevd(dep=param[4],model="neglog")
      chiGal=2-2*An}
      if(vtau<=0){
        chiGal=NA
      }
      chireal<-2-2^(1/theta)
      depreal=chireal
      totalchi[jo,]<-c(chiht,chilt,chiGum,chiNorm,chifgm,chiGal)
      names(totalchi)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      
      rmsechi[jo,]<-c(rmse(chireal,totalchi[jo,1]),rmse(chireal,totalchi[jo,2]),
                    rmse(chireal,totalchi[jo,3]),
                    rmse(chireal,totalchi[jo,4]),
                    rmse(chireal,totalchi[jo,5]),
                    rmse(chireal,totalchi[jo,6]))
      names(rmsechi)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      }
      if(mode=="AI"){
        etaht=condexres$etaht
        etalt<-jtres$etaJT
        etaGum<-1
        etafgm=0.5
        etaNorm<-(1+copulas[[2]]@estimate)/2
        
        # An<-abvevd(dep=param[4],model="neglog")
        etaGal=1
        etareal<-(1+rho)/2
        depreal=etareal
        totaleta[jo,]<-c(etaht,etalt,etaGum,etaNorm,etafgm,etaGal)
        names(totaleta)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
        # 
        rmseeta[jo,]<-c(rmse(etareal,totaleta[jo,1]),rmse(etareal,totaleta[jo,2]),
                        rmse(etareal,totaleta[jo,3]),
                        rmse(etareal,totaleta[jo,4]),
                        rmse(etareal,totaleta[jo,5]),
                        rmse(etareal,totaleta[jo,6]))
        names(rmseeta)= c("HT","LT","Gumcop","Normalcop","FGMcop","GalambosCop")
      }
      
      
      
      HTlinex[,jo]<-htl[,1]
      LTlinex[,jo]<-ltl[,1]
      Gumlinex[,jo]<-clines[[1]][,1]
      Normlinex[jo]<-clines[[2]][,1]
      FGMlinex[,jo]<-clines[[3]][,1]
      Gallinex[,jo]<-clines[[4]][,1]
      
      HTliney[,jo]<-htl[,2]
      LTliney[,jo]<-ltl[,2]
      Gumliney[,jo]<-clines[[1]][,2]
      Normliney[jo]<-clines[[2]][,2]
      FGMliney[,jo]<-clines[[3]][,2]
      Galliney[,jo]<-clines[[4]][,2]
      
      HTlined[,jo]<-htl[,3]
      LTlined[,jo]<-ltl[,3]
      Gumlined[,jo]<-clines[[1]][,3]
      Normlined[jo]<-clines[[2]][,3]
      FGMlined[,jo]<-clines[[3]][,3]
      Gallined[,jo]<-clines[[4]][,3]
      end_time <- Sys.time()
      print(paste0("loop duration = ",end_time - start_time))
    }







linesfinalx<-list(HTlinex,LTlinex, Gumlinex, Normlinex, FGMlinex,Gallinex)
linesfinaly<-list(HTliney,LTliney, Gumliney, Normliney, FGMliney,Galliney)
linesfinald<-list(HTlined,LTlined, Gumlined, Normlined, FGMlined,Gallined)

rbPal <- colorRampPalette(c("green","orange","red"))
adpd<-ra
plot(u2, col="grey",xlim=c(0,(1.5*max(adpd$x))),ylim=c(0,(1.5*max(adpd$y))),main=paste0("Joint exceedance curves for p = 0.001 \n ", "chi = ",round(depreal,3), " n = ",num.points))
legend(1.1*max(adpd$x),1.2*max(adpd$y),legend=c("True","L&T", "H&T","GumbelCop","NormalCop","FGMCop","GalambosCop"),
       col=c("blue", "green", "purple","red","red","red","red"), lty=c(1,1,1,3,4,5,6), cex=.9, lwd=2)
lines(ra,col="blue", lwd=3)
for(tt in 1:nsim){
HTlinec <- rbPal(10)[as.numeric(cut(100*HTlined[,tt],breaks = 10))]
points(HTlinex[,tt],HTliney[,tt],type="l", col="purple",lwd=1, pch=16)
lines(LTlinex[,tt],LTliney[,tt],type="l", col="darkgreen",lwd=1)
Glinec <- rbPal(10)[as.numeric(cut(100*Gumlined[,tt],breaks = 10))]
points(Gumlinex[,tt],Gumliney[,tt],type="l", col="red")
points(Normlinex[,tt],Normliney[,tt],type="l", col="darkred")
points(FGMlinex[,tt],FGMliney[,tt],type="l", col="darkred")
lines(Gallinex[,tt],Galliney[,tt],type="l", col="darkred")
 }


formL1<-matrix(ncol=3,nrow=10000)
pfinal<-list(formL1, formL1,formL1,formL1, formL1,formL1)

for (lis in 1:6){
  htpf<-c()  
  for(tt in 1:nsim){
    htp<-cbind(linesfinalx[[lis]][,tt],linesfinaly[[lis]][,tt],linesfinald[[lis]][,tt])
    htpf<-rbind(htpf,htp)
  }
  HTlinec <- rbPal(6)[as.numeric(cut(htpf[,3],breaks = 6))]
  plot(htpf[,1],htpf[,2],col=HTlinec,lwd=3, type="p")
  pfinal[[lis]]<-htpf
}


thelines<-transflines(linesx=linesfinalx,linesy=linesfinaly)

formL<-matrix(ncol=3,nrow=100)
linesICx<-list(formL, formL,formL,formL, formL,formL)
linesICy<-list(formL, formL,formL,formL, formL,formL)
linesICd<-list(formL, formL,formL,formL, formL,formL)

rmseEtaM<-matrix(ncol=3,nrow=6)
rmseChiM<-matrix(ncol=3,nrow=6)
ksresultM<-matrix(ncol=3,nrow=6)
cvmresM<-matrix(ncol=3,nrow=6)
eucldisLM<-matrix(ncol=3,nrow=6)
eucldisNM<-matrix(ncol=3,nrow=6)
biasNM<-matrix(ncol=3,nrow=6)
biasM<-matrix(ncol=3,nrow=6)
ChiM<-matrix(ncol=3,nrow=6)
EtaM<-matrix(ncol=3,nrow=6)

 ##################### Computing median and quantiles #############################

for (los in 1:6){
  if(mode=="AI"){
  rmseEtaM[los,1]<-median(as.numeric(rmseeta[,los]))
  rmseEtaM[los,2]<-quantile(as.numeric(rmseeta[,los]),.025,na.rm=T)
  rmseEtaM[los,3]<-quantile(as.numeric(rmseeta[,los]),.975,na.rm=T)

  EtaM[los,1]<-median(as.numeric(totaleta[,los]))
  EtaM[los,2]<-quantile(as.numeric(totaleta[,los]),.025,na.rm=T)
  EtaM[los,3]<-quantile(as.numeric(totaleta[,los]),.975,na.rm=T)
  }
  if(mode=="AD"){
  rmseChiM[los,1]<-median(as.numeric(rmsechi[,los]))
  rmseChiM[los,2]<-quantile(as.numeric(rmsechi[,los]),.025,na.rm=T)
  rmseChiM[los,3]<-quantile(as.numeric(rmsechi[,los]),.975,na.rm=T)

  ChiM[los,1]<-median(as.numeric(totalchi[,los]))
  ChiM[los,2]<-quantile(as.numeric(totalchi[,los]),.025,na.rm=T)
  ChiM[los,3]<-quantile(as.numeric(totalchi[,los]),.975,na.rm=T)
  }
  # ksresultM[los,1]<-median(as.numeric(ksresults[,los]))
  # ksresultM[los,2]<-quantile(as.numeric(ksresults[,los]),.025,na.rm=T)
  # ksresultM[los,3]<-quantile(as.numeric(ksresults[,los]),.975,na.rm=T)
  # 
  # cvmresM[los,1]<-median(as.numeric(cvmresults[,los]))
  # cvmresM[los,2]<-quantile(as.numeric(cvmresults[,los]),.025,na.rm=T)
  # cvmresM[los,3]<-quantile(as.numeric(cvmresults[,los]),.975,na.rm=T)

  eucldisLM[los,1]<-median(as.numeric(eucldist[,los]),na.rm=T)
  eucldisLM[los,2]<-quantile(as.numeric(eucldist[,los]),.025, na.rm=T)
  eucldisLM[los,3]<-quantile(as.numeric(eucldist[,los]),.975,na.rm=T)

  eucldisNM[los,1]<-median(as.numeric(eucldistN[,los]),na.rm=T)
  eucldisNM[los,2]<-quantile(as.numeric(eucldistN[,los]),.025,na.rm=T)
  eucldisNM[los,3]<-quantile(as.numeric(eucldistN[,los]),.975,na.rm=T)

  biasM[los,1]<-median(as.numeric(bias[,los]))
  biasM[los,2]<-quantile(as.numeric(bias[,los]),.025,na.rm=T)
  biasM[los,3]<-quantile(as.numeric(bias[,los]),.975,na.rm=T)

  biasNM[los,1]<-median(as.numeric(biasN[,los]))
  biasNM[los,2]<-quantile(as.numeric(biasN[,los]),.025,na.rm=T)
  biasNM[los,3]<-quantile(as.numeric(biasN[,los]),.975,na.rm=T)


x1<-c()
x2<-c()
x3<-c()
for (ios in 1:nsim)
  {
  x1<-c(x1,as.numeric(linesfinalx[[los]][,ios]))
  x2<-c(x2,as.numeric(linesfinaly[[los]][,ios]))
  x3<-c(x3,as.numeric(linesfinald[[los]][,ios]))

}
scs1<-scale(as.numeric(x1),center=F)
ss1<-attr(scs1,'scaled:scale')
scs2<-scale(as.numeric(x2),center=F)
ss2<-attr(scs2,'scaled:scale')
x1p<-as.vector(scale(as.numeric(x1),center=F))
x2p<-as.vector(scale(as.numeric(x2),center=F))
poco<-as.data.frame(cbind(x1p,x2p))
polco<-cart2pol(x1p, x2p)
lala<-seq(min(polco[,2]),max(polco[,2]),length.out = 100)
quantile(polco[,2],0.95)
for(al in 1:100)
  {
  alo<-lala[al]

  pre<-matrix(ncol=3,nrow=100)
  for (ibs in 1:nsim){

    y1<-as.numeric(linesfinalx[[los]][,ibs])/ss1
    y2<-as.numeric(linesfinaly[[los]][,ibs])/ss2
    y3<-as.numeric(linesfinald[[los]][,ibs])
    fshit<-cbind(y1,y2,y3)
    polco<-cart2pol(y1, y2)
    lapol<-polco[,2]
    sel<-abs(lapol-alo)
    if(length(which(sel==min(sel,na.rm = T)))>1){
      pre[ibs,]<-c(pol2cart(polco[which(sel==min(sel))[1],1],alo),fshit[which(sel==min(sel))[1],3])
    }else{pre[ibs,]<-c(pol2cart(polco[which(sel==min(sel)),1],alo),fshit[which(sel==min(sel)),3])}
  pre[ibs,1]<-pre[ibs,1]*ss1
  pre[ibs,2]<-pre[ibs,2]*ss2
  }
  alex<-as.data.frame(pre)
  linesICx[[los]][al,1]<-median(alex[,1])
  linesICy[[los]][al,1]<-median(alex[,2])
  linesICd[[los]][al,1]<-median(alex[,3])
  linesICx[[los]][al,2]<-quantile(alex[,1],0.025)
  linesICx[[los]][al,3]<-quantile(alex[,1],0.975)
  linesICy[[los]][al,2]<-quantile(alex[,2],0.025)
  linesICy[[los]][al,3]<-quantile(alex[,2],0.975)
}

}

plot(u2, col="grey",xlim=c(0,(1.5*max(adpd$x))),ylim=c(0,(1.5*max(adpd$y))),main=paste0("Joint exceedance curves for p = 0.001 \n ", "dep = ",round(depreal,3), " n = ",num.points))
legend(1.1*max(adpd$x),1.2*max(adpd$y),legend=c("True","L&T", "H&T","GumbelCop","NormalCop","FGMCop","GalambosCop"),
       col=c("blue", "green", "purple","red","red","red","red"), lty=c(1,1,1,3,4,5,6), cex=.9, lwd=2)
lines(ra,col="blue", lwd=3)


for (zg in 1:6){
coli <- rbPal(6)[as.numeric(cut(linesICd[[zg]][,1],breaks = 6))]
points(linesICx[[zg]][,1],linesICy[[zg]][,1],type="p" ,lwd=1,lty=1, col=zg+1)
lines(linesICx[[zg]][,2],linesICy[[zg]][,2],type="l" ,lwd=3,lty=2,col=zg+1)
lines(linesICx[[zg]][,3],linesICy[[zg]][,3],type="l" ,lwd=3,lty=2,col=zg+1)
polygon(c(linesICx[[zg]][,2],rev(linesICx[[zg]][,3])),c(linesICy[[zg]][,2],rev(linesICy[[zg]][,3])),col = gray.colors(zg,alpha=0.1*zg), border = FALSE)
}

require(plotrix)
plotCI(seq(1,6),eucldisLM[,1], ui=eucldisLM[,3], li=eucldisNM[,2], lwd=1, col=seq(2,7))
plotCI(seq(1,6),biasNM[,1], ui=biasNM[,3], li=biasNM[,2], lwd=1, col=seq(2,7))
if(mode=="AD"){
rmsechiT<-rbind(rmsechiT,rmseChiM)
totalchiT<-rbind(totalchiT,ChiM)
}
if(mode=="AI"){
rmseetaT<-rbind(rmseetaT,rmseEtaM)
totaletaT<-rbind(totaletaT,EtaM)
}

ksresulT<-rbind(ksresulT,ksresultM)
cvmresT<-rbind(cvmresT,cvmresM)
eucldisT<-rbind(eucldisT,eucldisLM)
eucldisTNorm<-rbind(eucldisTNorm,eucldisNM)

biasT<-rbind(biasT,biasM)
biasTNorm<-rbind(biasTNorm,biasNM)
# totaltauT<-cbind(totaltauT,totaltau)
paramT<-cbind(paramT,param)

linesfinal<-list(linesfinalx,linesfinaly,linesfinald)
names(linesfinal)=c("x","y","d")
linesIC<-list(linesICx,linesICy, linesICd)
names(linesIC)=c("x","y","d")
save(linesfinal,file=paste0(dir.coef,"/lines_dep",round(dep,2),"_nb",num.points,".Rdata"))
save(linesIC,file=paste0(dir.coef,"/linesIC95_dep",round(dep,2),"_nb",num.points,".Rdata"))


  }

eucldisT=as.data.frame(eucldisT)
names(eucldisT)=c("median","Q2.5","Q97.5")
eucldisTNorm=as.data.frame(eucldisTNorm)
names(eucldisTNorm)=c("median","Q2.5","Q97.5")
if(mode=="AD"){
rmsechiT=as.data.frame(rmsechiT)
names(rmsechiT)=c("median","Q2.5","Q97.5")
totalchiT=as.data.frame(totalchiT)
names(totalchiT)=c("median","Q2.5","Q97.5")
}
if(mode=="AI"){
rmseetaT=as.data.frame(rmseetaT)
names(rmseetaT)=c("median","Q2.5","Q97.5")
totaletaT=as.data.frame(totaletaT)
names(totaletaT)=c("median","Q2.5","Q97.5")
}
biasT=as.data.frame(biasT)
names(biasT)=c("median","Q2.5","Q97.5")
biasTNorm=as.data.frame(biasTNorm)
names(biasTNorm)=c("median","Q2.5","Q97.5")
ksresulT=as.data.frame(ksresulT)
names(ksresulT)=c("median","Q2.5","Q97.5")
cvmresT=as.data.frame(cvmresT)
names(cvmresT)=c("median","Q2.5","Q97.5")




paramT=as.data.frame(paramT)
if(mode=="AD"){
graphout<-list (t(eucldisT),t(eucldisTNorm),t(rmsechiT),t(totalchiT),t(biasT),t(biasTNorm),t(cvmresT),t(ksresulT))
names(graphout)=c("eucl_dist_curve_WeighNorm","eucl_dist_Norm_curve","RMSE_Chi","Chival","Bias","Bias_Norm","cvmStat","ksStat")
}
if(mode=="AI"){
  graphout<-list (t(eucldisT),t(eucldisTNorm),t(rmseetaT),t(totaletaT),t(biasT),t(biasTNorm),t(cvmresT),t(ksresulT))
  names(graphout)=c("eucl_dist_curve_WeighNorm","eucl_dist_Norm_curve","RMSE_Eta","Etaval","Bias","Bias_Norm","cvmStat","ksStat")
}  
save(graphout, file=paste0(dir.day,"/stat_output_F1_chi-",round(dep,2),"_chiv_",sdlog1,"_",sdlog2,".Rdata"))
save(paramT, file=paste0(dir.day,"/paramcopulas-",round(dep,2),"_chiv_",sdlog1,"_",sdlog2,".Rdata"))



}

  