# Bivariate_models

# Evaluating the efficacy of bivariate extreme modelling approaches for multi-hazard scenarios

Estimating risks generated by multi-hazard scenarios remains a challenge for practitioners. Here we evaluate the efficacy of bivariate extreme modelling approaches by fitting six distinct stochastic models to synthetic datasets. The properties of the synthetic datasets (marginal distributions, tail dependence structure) are chosen to match bivariate time series of environmental variables. The six models are copulas (one non-parametric, one semi-parametric, four parametric). We build 60 distinct synthetic datasets based on different parameters of log-normal margins and two different copulas. We contrast the model strengths (model flexibility) and weaknesses (poorer fits to the data). We find that no one model fits our synthetic data for all parameters, but rather a range of models are more appropriate To highlight the benefits of the systematic modelling framework developed, we consider the following environmental data: (i) daily precipitation and maximum wind gust in London, UK; (ii) daily mean temperature and wildfire number in Porto district, Portugal. In both cases there is good agreement in the estimation of bivariate return periods between models selected from the systematic framework developed in this study. Within this framework, we have explored a way to model multi-hazard events and identify the most efficient models for a given set of synthetic data and hazard sets. 
### 60 bivariate datasets
![SyntheticData](figures/Figure_6.png)
To assess the performance of each model,a selection of metrics and bivariate return periods are used. We contrast the strengths (e.g., flexibility of the model)
and weaknesses (e.g., poorer fits to the data) of the different models, finding that there is no one best model for fitting
our synthetic data for all parameters, but rather a range of models are more appropriate. 
## Application to real data
To highlight the benefits
of the systematic framework developed, we consider two pairs of natural hazards: extreme rainfall and extreme wind gust in the UK;
extreme temperature and wildfire in Portugal and apply our methodology to daily observation data. Within this framework,
we have explored a way to model multi-hazard events, identify the most efficient models for a given set of synthetic data 
and hazard sets and create a methodology which is applicable to a diverse range of natural hazards and multi-hazard scenarios.

### Bivariate joint level curve for max daily wind gust and total daily precipitation at Heathrow [UK]
![ResultsHeathrow](figures/Fig_WindRain.png)
### Bivariate condition level curve for mean daily temperature and total daily wildfires in Porto district [Portugal]
![ResultsPorto](figures/Fig_FireTemp.png)


